﻿@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section scripts{
    <script>
        $(document).ready(function () {
            $("#jqxwindow").jqxWindow({ height: 390, width: 675, theme: 'summer', isModal: true, autoOpen: false });
            $("#addrowbutton").click(function () {
                $("#jqxwindow").jqxWindow('open');
            });
            $("#button_input").click(function () {
                var data = $("#text_input").val();
                var dataValue = {
                    "data": data
                };
                $.ajax({
                    type: 'GET',
                    dataType: 'text',
                    url: '/WhitelistDomains/AddDomains',
                    data: dataValue,
                    contentType: "application/json; charset=utf-8",
                    success: function (data, status, xhr) {
                        // update command is executed.
                        $("#jqxgrid").jqxGrid('refreshdata');
                    },
                    error: function () {
                        // cancel changes.
                    }
                });

                $("#jqxwindow").jqxWindow('close');
            });
            $("#button_no").click(function () {
                $("#jqxwindow").jqxWindow('close');
            });
            var source =
                {
                    datafields:
                    [
                        { name: 'Id', type: 'number' },
                        { name: 'Domain', type: 'string' },
                        { name: 'AddedDate', type: 'date' },
                        { name: 'HtmlBanner', type: 'number' },
                        { name: 'Visible', type: 'number' },
                        { name: 'FamobiId', type: 'string' },
                        { name: 'Session', type: 'string' },
                        { name: 'AdRequest', type: 'number' },
                        { name: 'Active', type: 'number' },
                        { name: 'SyncTunnl', type: 'string' },
                        { name: 'R1', type: 'number' }

                    ],
                    updaterow: function (rowid, rowdata, commit) {
                        // synchronize with the server - send update command
                        var data = "update=true&Id=" + rowdata.Id + "&Active=" + rowdata.Active + "&HtmlBanner=" + rowdata.HtmlBanner + "&FamobiId=" + rowdata.FamobiId;

                        $.ajax({
                            dataType: 'json',
                            url: '/WhitelistDomains/UpdateDomainsInline',
                            data: data,
                            success: function (data, status, xhr) {
                                // update command is executed.
                                $("#jqxgrid").jqxGrid('refreshdata');
                                commit(true);
                            },
                            error: function () {
                                // cancel changes.
                                commit(false);
                            }
                        });
                    },
                    addrow: function (rowid, rowdata, position, commit) {
                        // synchronize with the server - send insert command
                        // call commit with parameter true if the synchronization with the server is successful
                        //and with parameter false if the synchronization failed.
                        // you can pass additional argument to the commit callback which represents the new ID if it is generated from a DB.
                        commit(true);
                    },
                    datatype: "json",
                    url: "/WhitelistDomains/GetWhiteListDomains",
                    filter: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'filter');
                    },
                    // update the grid and send a request to the server.
                    sort: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'sort');
                    },
                    root: "Rows",
                    beforeprocessing: function (data) {
                        source.totalrecords = data.TotalRows;
                    }
                };

            var isEditable = function (row) {
                return false;
            }

            var dataAdapter = new $.jqx.dataAdapter(source);

            var columnsrenderer = function (value) {
                return '<div style="text-align: center; margin-top:5px;"><b>' + value + '</b></div>';
            }

            var syncRenderer = function (row, columnfield, value, defaulthtml, columnproperties) {
                var color = value == "NOK" ? "red" : "green";
                return '<div style="text-align: center; margin-top:5px;color:' + color + ';">' + value + '</div>';
            }

            var cellsrenderer = function (row, columnfield, value, defaulthtml, columnproperties) {
                return '<div style="margin-left: 10px; margin-top:5px;">' + value + '</div>';
            }

            $("#jqxgrid").jqxGrid(
                {
                    width: "100%",
                    height: 650,
                    source: dataAdapter,
                    showfilterrow: true,
                    editable: true,
                    filterable: true,
                    pageable: true,
                    sortable: true,
                    pagesize: 20,
                    autoheight: true,
                    selectionmode: 'multiplecellsextended',
                    enablebrowserselection: true,
                    virtualmode: true,
                    rendergridrows: function (obj) {
                        return obj.data;
                    },
                    showtoolbar: true,
                    rendertoolbar: function (toolbar) {
                        var me = this;
                        var container = $("<div style='margin: 5px;'></div>");
                        toolbar.append(container);
                        container.append('<input id="addrowbutton" type="button" value="Add Domains" />');
                        $("#addrowbutton").jqxButton();
                        $("#addrowbutton").click(function () {
                            $("#jqxwindow").jqxWindow('open');
                        });
                    },
                    columns: [
                        { text: 'Id', datafield: 'Id', filtertype: 'textbox', hidden: true },
                        { text: 'Domain', datafield: 'Domain', filtertype: 'textbox', width: '18%', cellsrenderer: cellsrenderer, renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                        { text: 'Session', datafield: 'Session', filtertype: 'textbox', width: '8%', cellsrenderer: cellsrenderer, renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                        { text: 'Ad Request', datafield: 'AdRequest', filtertype: 'textbox', width: '9%', cellsrenderer: cellsrenderer, renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                         {
                             text: 'Html Banner', datafield: 'HtmlBanner', filtertype: 'textbox', cellsalign: 'center', width: '8%', renderer: columnsrenderer, sortable: true,
                             validation: function (cell, value) {
                                 if (value > 1 || value < 0) {
                                     return { result: false, message: "Must either be 0 or 1!" };
                                 }
                                 return true;
                             }
                         },
                        { text: 'Added On', datafield: 'AddedDate', filtertype: 'date', width: '10%', cellsalign: 'center', renderer: columnsrenderer, sortable: true, cellsformat: 'dd/MM/yyyy', cellbeginedit: isEditable },
                        {
                            text: 'Active', datafield: 'Active', filtertype: 'textbox', cellsalign: 'center', width: '10%', renderer: columnsrenderer, sortable: true,
                            validation: function (cell, value) {
                                if (value > 1 || value < 0) {
                                    return { result: false, message: "Must either be 0 or 1!" };
                                }
                                return true;
                            }
                        },
                        { text: 'Afilliate Id', datafield: 'FamobiId', filtertype: 'textbox', cellsrenderer: cellsrenderer, renderer: columnsrenderer, width: '8%', sortable: true },
                        { text: 'Sync Tunnl', datafield: 'SyncTunnl', filtertype: 'textbox', cellsrenderer: syncRenderer, renderer: columnsrenderer, width: '8%', sortable: true },

                        //VGD-144
                        {
                            text: 'Edit', datafield: 'Edit', columntype: 'button', width: '6%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return 'Edit'
                            }, buttonclick: function (row) {
                                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                window.location = '/WhiteListDomains/Edit/' + id;
                            }
                        },

                        {
                            text: 'Delete', datafield: 'Delete', columntype: 'button', width: '8%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return "Delete";
                            }, buttonclick: function (row) {
                                editrowindex = row;
                                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                window.location = '/WhitelistDomains/Delete/' + id;
                            }
                        },
                        {
                            text: 'Games', datafield: 'Games', columntype: 'button', width: '7%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return "Games";
                            }, buttonclick: function (row) {
                                editrowindex = row;
                                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "FamobiId");
                                window.location = '/WhitelistDomains/UnPublishedGames/' + id;
                            }
                        }
                    ]
                });
        });


        function TrimDomain(domain) {

            var words = ['www.', 'https://wwww.', 'http://wwww.'];

            for (var i = 0; i < words.length; i++) {

                if (domain.includes(words[i])) {
                    domain = domain.replace(words[i], '');
                    break;
                }
            }

            domain = domain.split('.')[0];
            return domain;
        }

    </script>
}

<div class="column">
    <div class="menu" style="text-align:left; color:black">
        <h2 style="width:100%; margin-left: 0 auto; margin-right:0 auto;">Whitelist Domains</h2>
        <div id="jqxgrid" style="width: 100% !important; margin-top:-20px;"></div>
    </div>
    <div id="jqxwindow">
        <div>
            &nbsp;
        </div>
        <div>
            <textarea id="text_input" rows="20" cols="80"></textarea>
            <br />
            <input type="button" value="Add" id="button_input" />
            <input type="button" value="Cancel" id="button_no" />
        </div>
    </div>
</div>
